###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$boardindexplver = "1 Gold - SP 1.3";

sub BoardIndex {
#  Start TodayCounter             #################  
	fopen(counting,"$vardir/counting.txt"); # Open the Count File
	$thecount = <counting>;
	$yesterdaycount = <counting>;
	$highestdaycount = <counting>;
	$highestonline = <counting>;
	$thismonth = <counting>;
	$sincestart = <counting>;
	fclose(counting);
# End TodayCounter            ###########
	#RECENT USERS LIST MOD START
	if ($username ne 'Guest' && $action ne 'login2')
	{
		require "$sourcedir/LogInOut.pl";
		&RecentUsersList;
	}
	#RECENT USERS LIST MOD END
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter, $secondlastposter ) = &BoardCountGet($curboard);

			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			
			if( $secondlastposter =~ m~\AGuest-(.*)~ ) {
				$secondlastposter = $1;
				$secondlastposterguest{$curboard} = 1;
			}
			$secondlastposter{$curboard} = $secondlastposter eq 'N/A' || ! $secondlastposter ? $txt{'470'} : $secondlastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
     	if( $enable_favorites && $enable_favdrop && $username ne 'Guest' ) { require "$sourcedir/Favor.pl"; &favordrop;
	$yymain .= qq~
<table border="0" width="100%">
  <tr>
    <td align="right" valign="bottom" colspan=2>$favselect<br><br></td></form>
  </tr>
</table>~;
	}
	#RECENT USERS LIST MOD START
	if ($rul_show_avatars && ($rul_avatar_width || $rul_avatar_height)) { $yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function resize_img(thisimage) {
	if (document.images) {
		tmp_image = new Image;
		tmp_image.src = thisimage.src;
		var tmpwidth = tmp_image.width;
		var tmpheight = tmp_image.height;

		maxwidth = $rul_avatar_width;
		maxheight = $rul_avatar_height;

		if (maxwidth != 0 && tmpwidth > maxwidth) {
			tmpheight = (tmpheight * maxwidth / tmpwidth);
			tmpwidth = maxwidth;
		}

		if (maxheight != 0 && tmpheight > maxheight) {
			tmpwidth = tmpwidth * maxheight / tmpheight;
			tmpheight = maxheight;
		}

		thisimage.width = tmpwidth;
		thisimage.height = tmpheight;
		thisimage.style.display = 'inline';
	}
}
// -->
</script>
~; }
	#RECENT USERS LIST MOD END


if($username ne "Guest") {
$yymain .= qq~

<SCRIPT LANGUAGE="JavaScript1.2">

img1 = new Image(); img1.src = "$imagesdir/100_glad.gif";
img2 = new Image(); img2.src = "$imagesdir/110_tilfreds.gif";
img3 = new Image(); img3.src = "$imagesdir/120_sej.gif";
img4 = new Image(); img4.src = "$imagesdir/130_normal.gif";
img5 = new Image(); img5.src = "$imagesdir/140_fjoget.gif";
img6 = new Image(); img6.src = "$imagesdir/150_svimmel.gif";
img7 = new Image(); img7.src = "$imagesdir/160_flov.gif";
img8 = new Image(); img8.src = "$imagesdir/170_bekymret.gif";
img9 = new Image(); img9.src = "$imagesdir/180_bedrovet.gif";
img10 = new Image(); img10.src = "$imagesdir/190_vred.gif";

var delEnh=80, totEnh=80;

var Imgs = [
"100_glad",
"110_tilfreds",
"120_sej",
"130_normal",
"140_fjoget",
"150_svimmel",
"160_flov",
"170_bekymret",
"180_bedrovet",
"190_vred"
]

var eleNum = Imgs.length, theNum = Imgs.length, ele

function showImg() {
	eleDiv = totEnh/eleNum;
	ele = Math.round(delEnh/eleDiv);
	if (ele < 0) ele = 0;
	if (ele >= eleNum) ele = eleNum-1;
	if (knapObj.id == "knapImg" && ele != theNum) {
		document.images.imag.src="$imagesdir/"+Imgs[ele]+".gif";
		theNum = ele;
	}
}


function saveImg() {
skydNu=false;
location.href="$cgi;action=savemembmood;themood="+Imgs[ele];
}

var ie=document.all
var ns6=document.getElementById&&!document.all

var skydNu=false
var x, knapObj, retning

function flytKnap(e) {
	if (skydNu) {
		glX = parseInt(knapObj.style.left+0)
		knapObj.style.left=ns6? temp2 + e.clientX - x : temp2 + event.clientX - x
		nyX = parseInt(knapObj.style.left+0)
		if (nyX > glX) retning = "vn"
		else retning = "hj"
		if (nyX < 4 && retning == "hj") { knapObj.style.left = 4; retning = "vn"; }
		if (nyX > 84 && retning == "vn") { knapObj.style.left = 84; retning = "hj"; }
		delEnh = parseInt(knapObj.style.left+0)-4
		showImg()
		document.onmouseup=saveImg
		return false
	}
}

function skydeKnap(e){
if (!ie&&!ns6) return
var flytobj=ns6? e.target : event.srcElement
var topelement=ns6? "HTML" : "BODY"
	while (flytobj.tagName != topelement && flytobj.className != "skyd"){
		flytobj=ns6? flytobj.parentNode : flytobj.parentElement
	}
	if (flytobj.className=="skyd"){
		skydNu=true
		knapObj=flytobj
		temp2 = parseInt(knapObj.style.left+0)
		x=ns6? e.clientX : event.clientX
		document.onmousemove=flytKnap
		return false
	}
}
document.onmousedown=skydeKnap
</SCRIPT>
~;
$thistime = time;
if(-e ("$memberdir/$username.mim")) {
	fopen(FILE,"$memberdir/$username.mim");
	@mimood = <FILE>;
	fclose(FILE);
	chomp $mimood;
	if(($thistime-$mimood[1]) < 86400) { $moodgif = $mimood[0]; }
	else { $moodgif = "100_glad"; }
}
else { $moodgif = "100_glad"; }
$yymain .= qq~
<table width="100%" align="center" border="0" cellspacing="0" cellpadding="0">
<tr>
<td align="left" valign="bottom">
<font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>
</td>
<td width="100" align="center" valign="bottom">
<img src="$imagesdir/$moodgif.gif" name="imag" height="60" width="60" border="0" align="absmiddle"><br>
</td>
<td width="110" align="left" valign="top">
<font size="1">
$mimtxt{'01'} $realname?
</font>
<div style="position: relative; z-index: 1; width: 102; height: 24; left: 0; top: 4; border-width: 2px; border-style: outset; background-color: #AAAAAA">
<img src="$imagesdir/knapbagr.gif" style="position: absolute; z-index: 2; width: 100; height: 20; left: 0; top: 0">
<img id="knapImg" src="$imagesdir/knap.gif" class="skyd" style="cursor: pointer; cursor: hand; z-index: 3; width: 13; height: 15; left: 4; top: 3">
</div>
</td>
</tr>
</table>

~;
}
else {
$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
$yymain .= qq~
<P align="left"><font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>~;
if ($showlatestmember) {
&LoadUser($latestmember);
$yymain .= qq~<BR>$txt{'797'}<a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>$txt{'798'}~;	
}
}

if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" align="center" height="60">
<script language="JavaScript1.2" type="text/javascript">
<!--
var delay = $fadertime
var bcolor = "$color{'windowbg2'}"
var tcolor = "$color{'fadertext'}"
var fcontent = new Array()
begintag = '<font size="2"><B>'
~;
fopen(FILE, "$vardir/news.txt");
@newsmessages = <FILE>;
fclose(FILE);
for($i=0; $i < @newsmessages; $i++) {
	$newsmessages[$i] =~ s/\n|\r//g;
	if($i != 0){ $yymain .= qq~\n~; }
	$message = $newsmessages[$i];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$message =~ s/\"/\\\"/g;
	$yymain .= qq~fcontent[$i] = "$message"~;
}
$yymain .= qq~
closetag = '</b></font>'
// -->
</script>
<script language="JavaScript1.2" type="text/javascript" src="$faderpath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
if (navigator.appVersion.substring(0,1) < 5 && navigator.appName == "Netscape") {
   var fwidth = screen.availWidth / 2;
   var bwidth = screen.availWidth / 4;
   document.write('<ilayer id="fscrollerns" width='+fwidth+' height=35 left='+bwidth+' top=0><layer id="fscrollerns_sub" width='+fwidth+' height=35 left=0 top=0></layer></ilayer>');
   window.onload = fade;
}
else if (navigator.userAgent.search(/Opera/) != -1 || (navigator.platform != "Win32" && navigator.userAgent.indexOf('Gecko') == -1)) {
   document.open();
   document.write('<div id="fscroller" style="width:90%; height:15px; padding:2px">');
   for(i=0; i < fcontent.length; ++i) {
      document.write(begintag+fcontent[i]+closetag+'<br>');
   }
   document.write('</div>');
   document.close();
   window.onload = fade;
}
else {
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px"></div>');
   window.onload = fade;
}
// -->
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}

	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		&sharedLogin;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td>~;

	#Check to see if the subcat.txt doesn't exist, if it doesn't we still need a forum header or it looks funny
	if(!(-e "$vardir/subcat.txt"))
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  <tr>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>Forum Name</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   </tr>
		  ~;
	}

	#This bit of code goes through and checks if we have visible categories. If there are no visible
	# categories, we need to still insert a <TABLE> string or else the info table will expand to full screen.
	$catisvisible="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		$catisvisible="true";
	}
	if($catisvisible eq "false")
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		~;
	}

	#Go through the categories and creat the tables if they are needed
	$foundasubcat="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####

		fopen(FILE, "$vardir/subcat.txt");
		@subcategories = <FILE>;
		fclose(FILE);
		$newsubcatlist="";

		#Go through the subcats and check to see if the curcat is found in the subcats file (It is a subcategory)
		foreach $cursubcat (@subcategories)
		{
			chomp($cursubcat);
			($cursubcatid,$cursubcatname) = split(/\|/,$cursubcat);
	
			#Check if we found a match
			if ($curcat eq $cursubcatid)
			{
				$foundasubcat="true";

				#This little code breaks the table away from the previous category
				if ($curcat ne @categories[0]) { $yymain .= qq~</TABLE><P>~; }

				 $yymain .= qq~
				    <table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
				      <tr>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$cursubcatname</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
				      </tr>
				~;
			}
		}

		#This code adds a table header for the very first category if the very first category is not found in subcat.txt
		if ((-e "$vardir/subcat.txt") && $foundasubcat eq "false")
		{
			$foundasubcat="true";
			$yymain .= qq~
			<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  	  <tr>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>Forum Name</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   	  </tr>
		  	~;
		}
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>
      </tr>~;
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			$secondlastposter = $secondlastposter{$curboard};
			unless( $secondlastposterguest{$curboard} || $secondlastposter{$curboard} eq $txt{'470'} ) {
				$secondlastposterid = $secondlastposter;
				&LoadUser($secondlastposterid);
				if($userprofile{$secondlastposter}->[1]) { $lastposter .= qq~<BR>--&gt;<a href="$scripturl?action=viewprofile;username=$secondlastposterid">$userprofile{$secondlastposter}->[1]</a>~; }
			}
			$secondlastposter ||= $txt{'470'};
			$secondlastposttime ||= $txt{'470'};

			# Count Auctions #
			fopen(THR, "$boardsdir/$curboard.txt") || die "$txt{'230'} ($boardsdir/$curboard.txt) :: $!";
			@contents = <THR>;
			fclose(THR);
			$auctioncounter = 0;
			$showauction = 0;
			foreach $line (@contents){
				($testthread, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy) = split (/\|/, $line);
				if (-e "$datadir/$testthread.auction"){
					$auctioncounter++;
					if ($showauction == 0){
					if (!(-e "$datadir/$testthread.auctl")){ 
						fopen (FILE, "$datadir/$testthread.auction");
						@auctiondata = <FILE>;
						fclose (FILE);
						$bidduration = $auctiondata[5];
						$bidstart = $auctiondata[12];
						if (-e "$datadir/$testthread.auctx"){
							fopen (FILE, "$datadir/$testthread.auctx");
							@extdata = <FILE>;
							fclose (FILE);
							$extnum = 0;
							$exttime = 0;
							foreach $extention(@extdata){
								chomp $extention;
								$extnum++;
								$exttime = $exttime + $extention;
							}
						}
						$bidtimeleft = 0;
						$todaytime = time; 
						$dif = (($todaytime - $bidstart)/86400); 
						if(!$dif) { $dif = 0; } 
						$bidtimeleft = sprintf("%.1f",$bidduration - $dif + $exttime);
						if($bidtimeleft >0){ 
							if (-e "$datadir/$testthread.bids"){
								fopen (BID, "$datadir/$testthread.bids");
								@bids = <BID>;
								fclose (BID);
								foreach $bidline(@bids){
									chomp $bidline;
									$highestbid = 0;
									@biditem = split(/\|/,$bidline);
									if($biditem[2] >= $highestbid){
										$highestbid = $biditem[2];
										$hbuser = $biditem[0];
										if ($hbuser eq $username) {$showauction = 0;} else {$showauction = 1;}
									}
								}
							}
						}
					}
					}
				}
			}
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} )) {
				if ($showauction == 1 && $username ne 'Guest'){
					$new = qq~<img src="$imagesdir/on_auction.gif" alt="$txt{'333a'}" border="0">~;
				} elsif (($showauction == 0 || $auctioncounter == 0) && $username ne 'Guest' ){
					$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
				}
			}
			else { 
				if ($showauction == 1 && $username ne 'Guest'){
					$new = qq~<img src="$imagesdir/off_auction.gif" alt="$txt{'334a'}" border="0">~;
				} elsif ($showauction == 0 || $auctioncounter == 0 || $username eq 'Guest'){
					$new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~;
				}
			}
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%" onMouseOver="this.style.backgroundColor='$hover{'cellhover'}'; this.style.cursor='hand';" onMouseOut="this.style.backgroundColor='$hover{'windowbg2'}';" onclick="window.location.href='$scripturl?board=$curboard'"$curboardname'">
        <font size="2"><a name="$curboard" href="$scripturl?board=$curboard">$boardpic{$curboard}<b>$curboardname $boardpwpic</b></a></font>
        <br><font size="1">$curboarddescr<BR>
        <i>$showmods</i></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$lastposttime{$curboard}<BR>$txt{'525'} $lastposter</font></td>
      </tr>~;
		}
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; }
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
### AIMB START ###
if($userimcfg[5] eq "on") {
$yymain .= qq~<script language="javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~; }
else {
$yymain .= qq~<script language="javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~; }

if ($minnum == $numibox && $enable_imlimit) {
	$yymain .= qq~<script language="javascript">
	if(confirm('$imtxt{'91'}')) { viewinstant(); } else cancel() </script>~;
}

if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IM; 
}

if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IMOUT; 
}

if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $storenum $imtxt{'12'} $imtxt{'46'}!\\n$numstore $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_STORE; 
}

$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;
### AIMB END ###
		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1">
            <img src="$imagesdir/on_auction.gif" border=0 alt="$txt{'333a'}"> $txt{'333a'}<br>
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}<br>
            <img src="$imagesdir/off_auction.gif" border=0 alt="$txt{'334a'}"> $txt{'334a'}<br>
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1>&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}

	#set the correct rowspan for the RECENT USERS LIST main cell
	$rul_rowspan = ($username eq 'Guest') ? $rul_rowspan : $rul_rowspan - 2;

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<BR><BR>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
      </tr>~;
###Custom Weather Mod -  Powered by http://weatherroom.com###

if($weathercentershow == '1' && ( $username ne 'Guest' )) {
 $wetbackbg = "FFFFFF";             # weather Background color
 $wetfontcolor = "000000";             # weather text font color
fopen(FILE, "$memberdir/$username.wet", 1); 
        @wetsettings = <FILE>;
        fclose <FILE>;
        chomp @wetsettings;   
            if ($wetsettings[0] ne '')
            {
          $yymain .= qq~
<tr>
    <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg"> <b>$txtwet{'0'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/glove.gif" border="0" width="16" height="17"></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">
<a href="http://www.weatherroom.com/forecast/$wetsettings[0].html"><img src="http://www.weatherroom.com/cgi-bin/weather.cgi?forecast=zone&hwvtc=$wetfontcolor&hwvbg= $wetbackbg&pands=$wetsettings[0]&config=png&alt=hwizone&daysonly=1" alt="Weather for $wetsettings[0] provided by weatherroom.com" border="0"></a><p align="right"><font size="1">Powered by <a href="http://www.addresses.com/weather.php">Addresses.com 
Weather </a></font></right>
</td>
</tr>~;
}

  }
###Custom Weather Mod -  Powered by http://weatherroom.com####
      <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$rul_users_display $rul_txt{'1'}</b></font></td>
      </tr>~;
	$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'200'}</b></font></td>
		<td rowspan="$rul_rowspan" class="windowbg2" bgcolor="$color{'windowbg'}" valign="top" width="25%">~;
	  
	&RecentUsersListShow;
	
	$yymain .= qq~
      </td></tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	    <td valign="top" align="left" width="40%"><font size="1">
	    $txt{'488'} <a href="$scripturl?action=mlall"><B>$memcount</B></a>
	    ~;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'201'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;
	}
open(FILE,"$vardir/usertoday.txt");

@utoday=<FILE>;

close(FILE);



$usertodaycount = @utoday;

$usertoday = '';

for($a=1;$a < $usertodaycount;$a++)

{

	$utoday[$a] =~ s/\n//gi;

	$name = $utoday[$a];

	if($useraccount{$name} eq ''){&LoadUser($name);}

	$usertoday .= qq~<a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a>, ~;

	if($name eq $username){$Inserted = 'true';}

}

$usertodaycount = $usertodaycount-1;



if($utoday[0] != $mday)

{

	open(FILE,">$vardir/usertoday.txt");

	print FILE "$mday\n";

	if($username ne 'Guest')

	{

		print FILE "$username\n";

	}

	fclose(FILE);

}

elsif($username ne 'Guest' && $Inserted ne 'true')

{

	open(FILE,">>$vardir/usertoday.txt");

	print FILE "$username\n";

	fclose(FILE);
	}
	
	##  Start Today Counter
	
	$gueststoday=$thecount-$usertodaycount  ; 
	
	$totalusersnow=$guests+$numusers;
	
	     if ($gueststoday < 0) {
	
	        $gueststoday = '0';
	
	        }
	
	
	
	if ($totalusersnow > $highestonline) {   # only if New User High is set
	
	chomp $thecount;
	
	chomp $yesterdaycount;
	
	chomp $highestdaycount;
	
	chomp $highestonline;
	
	chomp $thismonth;
	
	chomp $sincestart;
	
	fopen (counting, ">$vardir/counting.txt");
	
	print counting "$thecount\n$yesterdaycount\n$highestdaycount\n$totalusersnow\n$thismonth\n$sincestart\n" ;
	
	fclose (counting);
	
	# end Today Counter
	


}	
	$yymain .= qq~
	    $ims
	    </font></td>
	  </tr>
	</table>
	</font></td>
	~;
	if($totalt > 0) {
		require "$sourcedir/TopStats.pl";
		&TopLink;
	}
	$yymain .= qq~
	~;	
		## WHOSON MOD START ##
			if ( $guestaccess != 0 ) {
				$countonl = $numusers + $guests;
			} else {
				$countonl = $numusers;
			}
			if ( $guests == 1 ) { $uguest = qq~$guests $txt{'28'},~; }
			else { $uguest = qq~$guests $txt{'141'},~; }
			if ( $numusers == 1 ) { $uuser = qq~$numusers $who{'103'}~; }
			else { $uuser = qq~$numusers $txt{'142'}~; }
			open( FILE, "$vardir/mostuser.txt" );
			@onlcount = <FILE>;
			close( FILE );
			if ( $countonl > $onlcount[0] ) {
				fopen( FILE, ">$vardir/mostuser.txt" );
				print FILE "$countonl\n";
				print FILE "$date";
				fclose( FILE );
			}
			if ( $username ne 'Guest' ) {
				$onlcount[1] = &timeformat( $onlcount[1] );
				if ( $onlopt == 1 ) {
					if ( $countonl == 1 ) {
						$uwhoonline .= qq~&#187; <a href="$scripturl?action=who">$who{'99'} ($countonl) $who{'100a'}</a> &#171;<br>~;
					}
					else {
						$uwhoonline .= qq~&#187; <a href="$scripturl?action=who">$who{'98'} ($countonl) $who{'100b'}</a> &#171;<br>~;
					}
				}
				if ( $Show_MostUsers == 1 ) {
					$uonline .= qq~<BR>$mosttxt{'01'} $onlcount[1] $mosttxt{'02'} $onlcount[0] $mosttxt{'03'}~;
				}
			}
			## WHOSON MOD END ##
		$yymain .= qq~
            <!-- WHOSON MOD START -->
                  </tr>~;
            	if ($Show_OnlineBar == 1 || $Show_OnlineBar eq "") {
            		$yymain .= qq~
                  <tr>
                    <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'158'}</b></font></td>
                  </tr><tr>
                    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
                    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
                    <table width="98%" cellpadding="3" align="center">
                      <tr>
                        <td valign="top" align="left"><font size="1">
                        $uwhoonline$uguest $uuser<BR>$users<BR>$uttxt{'1'} $usertodaycount $uttxt{'2'} $uonline
                        <br><br>Highest Online: $highestonline<br><hr><br><br>Members Today: $usertodaycount <br>Guests Today: $gueststoday<br><br>Today: $thecount <br>Yesterday: $yesterdaycount <br>Highest Day: $highestdaycount <br>This Month: $thismonth<br>Total Visitors: $sincestart <br><br>
                      </tr>
                    </table>
                    </font></td>
                  </tr>~;
                  	if( $tellfriendshowbottom == '1') {
		  	$yymain .= qq~
		         <tr>
		          <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2"><b>$txttellfriend{'718'}</b></font></td>
		         </tr><tr>
		          <td class="windowbg" bgcolor="$color{'windowbg'}" width="10" valign="middle" align="center">
		 <img src="$imagesdir/tell.gif" border="0" alt="$txttellfriend{'718'}" align="absmiddle"></td>
		  <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		 
		 
		 <table cellspacing='4' cellpadding='1' border='0' width='100%'>
		 <tr>
		 <td width="95%" align='left' colspan='4'><font size="1"><b> $txttellfriend{'719'}</b></font></td>
		 </tr>
		 <tr>
		 <form action="$cgi;action=tellafriend2" method="post">
		 <input type="hidden" name="y_email" size="20" maxlength="40" value="$settings[2]">
		 <td  width="30%" align='left' valign='middle'>
		      <input type="text" name="y_name" size="20" maxlength="40" value="$settings[1]">
		 </td>
		 <td width="32%" align='left' valign='middle'>
		         <input type="text" name="r_name" size="20" maxlength="40"  value="$txttellfriend{'725'}" onFocus="this.value=''">
		 </td>
		 <td  width="32%" align='left' valign='middle'>
		 <input type="text" name="r_email" size="30" maxlength="40"  value="$txttellfriend{'726'}" onFocus="this.value=''">
		 </td>
		  <td width="5%" align='left' valign='middle'>
	          <input type="submit" name="Send" value="$txttellfriend{'727'}">
		  </td>
		  </form>
		  </tr>
		  </table>
		  </td>
	         </tr>~;
		  
	}
            	}
            ## WHOSON MOD END ##
########### Newcalendar mod start #######################
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag ==1 ) {
	if ($newcalmoon2 == 1) {
		require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$moonpict = qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$moonpict = qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$moonpict = qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	} else {
		$moonpict = qq~<img src="$imagesdir/newcal.gif" alt="" border="0">~;
	}
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar">$moonpict</a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/NewcalIndex.pl";
if ($newcalindexmini == 1) {
	$yymain .=qq~
<table width='100%'>
  <tr>
    <td valign='top'>
      <font size="1">~;
        &IndexCal;
	$yymain .=qq~
      </font>
    </td><td align='right'>~;
	require "$sourcedir/NewcalPost.pl";
      &MiniCalYY;
      $yymain .=qq~$yyminical~;
	$yymain .=qq~
    <td>
  </tr>
</table>~;
} else {
	&IndexCal;
}
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########### Newcalendar mod end #######################
########chat insertion########### 
require "$vardir/ChatSettings.txt"; 
$numchatters = 0; 
if ($chatopen == 1 || $settings[7] eq 'Administrator' || $settings[7] eq $chatgroup ) { 
open(OF,"$Variables/online.txt"); 
@ary = <OF>; 
$count = "0"; 
foreach $line (@ary) { 
$count++; 
} 
$yymain .=qq~ 
<tr> 
<td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$chadmtxt{'7'}</b></font></td> 
</tr><tr> 
<td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td> 
<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1> 
<table width="98%" cellpadding="3" align="center"> 
<tr> 
<td valign="top" align="left"><font size="1"> 
~; 
$cguests = 0; 
$cusers = ''; 

open(OF,"$vardir/online.txt") or dienice ("Can't open file: $!"); 
@ary = <OF>; 
foreach $line (@ary) { 
chomp($line); 
($of,$name,$ip,$displayname,$level,$time,$non1,$non2) = split(/\/,$line); 
if( $name ) { 
if( exists $userprofile{$name} ) { 
++$numchatters; 
if ($numchatters eq 1) 
{ 
$cusers .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">\n$displayname</a><font size=1></font>\n~; 
} 
else 
{ 
$cusers .= qq~, <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">\n$displayname</a><font size=1></font>\n~; 
} 

} 
else { 
++$cguests; 
} 
} 
close(OF); 
} 


if ($numchatters ne 0) 
{ 
$cusers .= qq~ $chadmdbitxt{'2'}.\n~; 

} 
else 
{ 

$cusers .= qq~ $chadmdbitxt{'1'}.\n~; 
} 

$yymain .=qq~ 
$cusers<br /> 
~; 

$windowname=$mbname; 
$windowname=~ s/ //g; 
$windowname=~ s/\W//g; 

if ($password eq ""){ 
if ($enable_guestposting == 0){ 
$yymain .=qq~$chadmdbitxt{'3'} <a href="http://www.mygarthamlock.co.uk/irc/index.php" target=newWindow>$chadmdbitxt{'4'}</a>.~; 
} 
else { 
$yymain .=qq~$chadmtxt{'9'}$cguests<br>\n<br> <a href=http://www.mygarthamlock.co.uk/irc/index.php"\',\"$windowname\")>$chadmtxt{'10'}</a> 
~; 
} 
} 

elsif ($password ne "") { 
if ($enable_guestposting == 1){ 
$yymain .=qq~$chadmtxt{'9'}$cguests<br>~; 
} 

$yymain .=qq~<br><a href=\'http://www.mygarthamlock.co.uk/irc/index.php',\"$windowname\")>$chadmtxt{'10'}</a> ~; 
} 
$yymain .=qq~ 
</font></td> 
</tr> 
</table> 
</font></td> 
</tr>~; 
} 
########chat ended############ 
	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;
	if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
#		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}

#RECENT USERS LIST
#v1.4
#OUTPUTS A TABLE WITH $rul_users_display ROWS - ONE FOR EACH USER IN THE LIST
sub RecentUsersListShow
{
	fopen(FILE, "$vardir/lastuseronline.txt"); @lastusers = <FILE>; fclose(FILE); chomp @lastusers;
	$counter = 1;

	$yymain .= qq~<table border="0" cellspacing="0" cellpadding="3">~;

	foreach $lastuser_line (@lastusers)
	{
		($last_username, $last_userwhen) = split(/\|/, $lastuser_line);

		#is this user online now?
		$online_now = ($users =~ /username=$last_username"/) ? "<br>$rul_txt{'2'}" : '';

		#it should never happen, but a Guest entry might have been stored in the file. this avoids showing it 
		if (fopen(MFILE, "$memberdir/$last_username.dat"))
		{
			@memberinfo = <MFILE>; fclose(MFILE); chomp @memberinfo;
			$last_userwhen = ($rul_show_time) ? '<br>' . &timeformat($last_userwhen) : '';

			#do we want to show an avatar?
			if ($rul_show_avatars)
			{
				#correct url allowing for custom avatars
				if ($memberinfo[13] =~ m~\Ahttp://~) { $avatar = $memberinfo[13]; }
				else { $avatar = $facesurl . '/' . $memberinfo[13]; }
			
				#is resizing enabled or shall we just show a plain image tag?
				#if we're using avatar resizing
				if ($rul_avatar_width || $rul_avatar_height)
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username"><img src="$avatar" style="display:none" onerror="javascript:this.style.display='inline'" onload="javascript:if(this.style.display=='none'){resize_img(this)}" alt="$rul_txt{'12'} $memberinfo[1]" border="0" hspace="3"></a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username"><img src="$avatar" style="display:none" onerror="javascript:this.style.display='inline'" onload="javascript:if(this.style.display=='none'){resize_img(this)}" alt="$rul_txt{'13'} $memberinfo[1]" border="0" hspace="3"></a></td>~; }
					else { $avatars_cell = qq~<td><img src="$avatar" style="display:none" onerror="javascript:this.style.display='inline'" onload="javascript:if(this.style.display=='none'){resize_img(this)}" alt="$memberinfo[1]" border="0" hspace="3"></td>~; }
				}
				#else we're not using resizing so just use the normal image tag
				else
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username"><img src="$avatar" border="0" alt="$rul_txt{'12'} $memberinfo[1]" hspace="3"></a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username"><img src="$avatar" border="0" alt="$rul_txt{'13'} $memberinfo[1]" hspace="3"></a></td>~; }
					else { $avatars_cell = qq~<td><img src="$avatar" border="0" alt="$memberinfo[1]" hspace="3"></td>~; }
				}
			}
			#else we're not showing avatars, so just show the text counter
			else { $avatars_cell = qq~<td valign="top"><font size="1">$counter.</font></td>~; }

			#output this row
			$yymain .= qq~<tr>$avatars_cell<td><font size="1"><a href="$cgi;action=viewprofile;username=$last_username">$memberinfo[1]</a>$last_userwhen$online_now</font></td></tr>~;
			}

			$counter++;
	}

	$yymain .= qq~</table>~;
}



sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

sub SaveMembMood {
	$moodtime = time;
	fopen(FILE, ">$memberdir/$username.mim", 1);
		print FILE "$INFO{'themood'}\n";
		print FILE "$moodtime\n";
	fclose(FILE);
	&BoardIndex;
}

1;